#ifndef CHIP_CLK_H
#define CHIP_CLK_H

#include "chip_std_defs.h"
#include "chip_clk_defs.h"
#include "chip_cfg_defs.h"

#define CHIP_CLK_HSE_EN  (CHIP_CLK_HSE_MODE != CHIP_CLK_EXTMODE_DIS)
#define CHIP_CLK_LSE_EN  (CHIP_CLK_LSE_MODE != CHIP_CLK_EXTMODE_DIS)


#if CHIP_CLK_HSE_EN
    #ifndef CHIP_CFG_CLK_HSE_FREQ
        #error HSE clock frequency is not specified
    #endif
    #define CHIP_CLK_HSE_FREQ       CHIP_CFG_CLK_HSE_FREQ
#ifdef CHIP_CFG_CLK_HSE_CSS_EN
    #define CHIP_CLK_HSE_CSS_EN     CHIP_CFG_CLK_HSE_CSS_EN
#else
    #define CHIP_CLK_HSE_CSS_EN     0
#endif
#else
    #define CHIP_CLK_HSE_FREQ       0
    #define CHIP_CLK_HSE_CSS_EN     0
#endif



#if CHIP_CLK_PLL1_EN
    #define CHIP_CLK_PLL1_SRC_ID    CHIP_CLK_ID_VAL(CHIP_CLK_PLL1_SRC)
#if CHIP_CLK_PLL1_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_PLL1IN_FREQ    (CHIP_CLK_HSI_FREQ/2)
    #define CHIP_CLK_PLL1IN_EN      CHIP_CLK_HSI_EN
#elif CHIP_CLK_PLL1_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_PLL1IN_FREQ    (CHIP_CLK_HSE_FREQ/CHIP_CLK_HSE_PLLIN_DIV)
    #define CHIP_CLK_PLL1IN_EN      CHIP_CLK_HSE_EN
#else
    #define CHIP_CLK_PLL1IN_FREQ    0
    #define CHIP_CLK_PLL1IN_EN      0
#endif
#define CHIP_CLK_PLL1_FREQ          (CHIP_CLK_PLL1IN_FREQ  * CHIP_CLK_PLL1_MUL)
#else
#define CHIP_CLK_PLL1IN_FREQ        0
#define CHIP_CLK_PLL1IN_EN          0
#define CHIP_CLK_PLL1_FREQ          0
#endif



#define CHIP_CLK_SYS_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_SYS_SRC)
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSI_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSE_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_PLL1_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_PLL1_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_PLL1_EN
#else
    #define CHIP_CLK_SYS_FREQ 0
    #define CHIP_CLK_SYS_EN   0
#endif


#if CHIP_CLK_MCO_EN
    #define CHIP_CLK_MCO_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_MCO_SRC)

    #if CHIP_CLK_MCO_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_SYS_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_SYS_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSI_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_PLL1_ID
        #define CHIP_CLK_MCO_SRC_FREQ (CHIP_CLK_PLL1_FREQ/2)
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_PLL1_EN
    #else
        #define CHIP_CLK_MCO_SRC_FREQ 0
        #define CHIP_CLK_MCO_SRC_EN   0
    #endif
    #define CHIP_CLK_MCO_FREQ   (CHIP_CLK_MCO_SRC_FREQ)
#endif




#define CHIP_CLK_AHB_FREQ       (CHIP_CLK_SYS_FREQ / CHIP_CLK_AHB_DIV)
#define CHIP_CLK_APB1_FREQ      (CHIP_CLK_AHB_FREQ / CHIP_CLK_APB1_DIV) /* частота шины APB1 */
#define CHIP_CLK_APB2_FREQ      (CHIP_CLK_AHB_FREQ / CHIP_CLK_APB2_DIV) /* частота шины APB2 */

#define CHIP_CLK_AHB_EN         1
#define CHIP_CLK_APB_EN         1
#define CHIP_CLK_APB1_EN        1
#define CHIP_CLK_APB2_EN        1

#define CHIP_CLK_CPU_FREQ       CHIP_CLK_AHB_FREQ
#define CHIP_CLK_SYSTICK_FREQ   CHIP_CLK_AHB_FREQ /* есть опция использовать AHB_FREQ/8, но в CMSIS она не используется */

#define CHIP_CLK_IWDG_FREQ      CHIP_CLK_LSI_FREQ


/* частота таймеров в 2 раза больше частоты шины APB, если только делитель
 * для ABP не равен 1 */
#if CHIP_CLK_APB1_DIV == 1
    #define CHIP_CLK_APB1_TIM_FREQ  CHIP_CLK_APB1_FREQ
#else
    #define CHIP_CLK_APB1_TIM_FREQ  (2*CHIP_CLK_APB1_FREQ)
#endif
#if CHIP_CLK_APB2_DIV == 1
    #define CHIP_CLK_APB2_TIM_FREQ  CHIP_CLK_APB2_FREQ
#else
    #define CHIP_CLK_APB2_TIM_FREQ  (2*CHIP_CLK_APB2_FREQ)
#endif


#define CHIP_CLK_TIM1_FREQ      CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM2_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM3_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM4_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM5_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM6_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM7_FREQ      CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM8_FREQ      CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM9_FREQ      CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM10_FREQ     CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM11_FREQ     CHIP_CLK_APB1_TIM_FREQ
#define CHIP_CLK_TIM12_FREQ     CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM13_FREQ     CHIP_CLK_APB2_TIM_FREQ
#define CHIP_CLK_TIM14_FREQ     CHIP_CLK_APB2_TIM_FREQ



#define CHIP_CLK_ADC_FREQ       (CHIP_CLK_APB2_FREQ/CHIP_CLK_ADC_DIV)

#define CHIP_CLK_USART1_FREQ    CHIP_CLK_APB2_FREQ
#define CHIP_CLK_USART2_FREQ    CHIP_CLK_APB1_FREQ
#define CHIP_CLK_USART3_FREQ    CHIP_CLK_APB1_FREQ
#if CHIP_DEV_UART_CNT >= 4
#define CHIP_CLK_UART4_FREQ     CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_UART_CNT >= 5
#define CHIP_CLK_UART5_FREQ     CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_UART_CNT >= 6
#define CHIP_CLK_UART6_FREQ     CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_UART_CNT >= 7
#define CHIP_CLK_UART7_FREQ     CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_UART_CNT >= 8
#define CHIP_CLK_UART8_FREQ     CHIP_CLK_APB1_FREQ
#endif

#define CHIP_CLK_SPI1_FREQ      CHIP_CLK_APB2_FREQ
#if CHIP_DEV_SPI_CNT >= 2
#define CHIP_CLK_SPI2_FREQ      CHIP_CLK_APB1_FREQ
#endif
#if CHIP_DEV_SPI_CNT >= 3
#define CHIP_CLK_SPI3_FREQ      CHIP_CLK_APB1_FREQ
#endif












#endif // CHIP_CLK_H
